//===============================================================================
// Copyright (C) 2003 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================

using System;

namespace Microsoft.ApplicationBlocks.Common.Crypto {
    /// <include file='doc\DPAPIStore.uex' path='docs/doc[@for="DPAPIStore"]/*'/>
    /// <devdoc>
    /// Specifies which key will be used to encrypt an item.
    /// </devdoc>
    public enum DPAPIStore {
        /// <include file='doc\DPAPIStore.uex' path='docs/doc[@for="DPAPIStore.Machine"]/*'/>
        Machine = 1, 
        /// <include file='doc\DPAPIStore.uex' path='docs/doc[@for="DPAPIStore.User"]/*'/>
        User = 2
    };
}