using System;
using System.Data;
using System.Data.SqlClient;
using System.Web.Security;
using System.Windows.Forms;

namespace SQLInjection
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
			frmLogin login = new frmLogin();
			DialogResult ret = DialogResult.OK;

			while (ret != DialogResult.Cancel)
			{
				ret = login.ShowDialog();
				if (ret == DialogResult.OK)
				{
					bool Result;
					if (login.AllowSqlInjection == true)
					{
						Result = Authenticate(login.UserName, login.Password);
					}
					else
					{
						Result = Authenticate(login.UserName, login.Password, true);
					}
					if (Result == true)
					{
						Application.Run(new Form1());
					}
					else
					{
						MessageBox.Show("Authentication invalid", "Invalid Credentials", 
							MessageBoxButtons.OK, MessageBoxIcon.Warning);
					}
				}
			}
		}

		private static bool Authenticate(string UserName, string Password)
		{
			SqlConnection conn = new SqlConnection(
				"Server=(local);Database=Security;Integrated Security=true");

			try
			{
				conn.Open();
				string hashedPass = new 
					Utility.Cryptography("NorthwindKey").ComputeHash(Password);
				SqlCommand cmd = new 
					SqlCommand("select UserName from Security_tbUser " + 
		" where UserName='" + UserName + 
"' and Password='" + hashedPass + "'", conn);
				bool RetVal = null != cmd.ExecuteScalar();
				return RetVal;
			}
			finally
			{
				conn.Close();
			}
		}

		private static bool Authenticate(
			string UserName, string Password, bool DefeatSqlInjection)
		{
			// first, validate the username and password are the right length
			if (UserName.Length <= 20 && Password.Length <= 40)
			{
				// second, check for questionable strings...
					// PRINCIPAL OF LEAST PRIVILEGE: NEVER NEVER NEVER
					// USE sa ACCOUNT IN A CONNECTION STRING
					SqlConnection conn = new SqlConnection(
						"Server=(local);Database=Security;Integrated Security=True");
					try
					{
						conn.Open();
						string hashedPass = new 
							Utility.Cryptography("NorthwindKey").ComputeHash(Password);
						// Third, USE PARAMETERS instead of dynamic SQL
						SqlCommand cmd = new 
							SqlCommand("select UserName from Security_tbUser" +
" where UserName=@UserName and Password=@Password", conn);
						cmd.Parameters.Add(new SqlParameter("@UserName", UserName));
						cmd.Parameters.Add(new SqlParameter("@Password", hashedPass));
						// Fourth, consider moving SQL into a stored procedure
						bool RetVal = null != cmd.ExecuteScalar();
						return RetVal;
					}
					finally
					{
						conn.Close();
					}
			}
			return false;
		}
	}
}
