//=============================================================================
// Copyright  2004 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//=============================================================================
using System;

namespace Microsoft.ApplicationBlocks.SmartClient.Offline
{
	/// <summary>
	/// This class constructs the ReferenceDataCache and exposes it as a property
	/// </summary>
	public class ReferenceDataCacheBuilder
	{
		private IReferenceDataCache referenceDataCache;

		/// <summary>
		/// Getter property to expose the ReferenceDataCache
		/// </summary>
		public IReferenceDataCache ReferenceDataCache { get { return referenceDataCache; }}

		/// <summary>
		/// Constructor responsible for instantiating the ReferenceDataCache
		/// </summary>
		public ReferenceDataCacheBuilder()
		{
			referenceDataCache = new ReferenceDataCache();
		}
	}
}
