using System.Reflection; 
using System.Runtime.CompilerServices;
using System.Security.Permissions;
using System.Net;

//
// General Information about an assembly is controlled through the following 
// set of attributes. Change these attribute values to modify the information
// associated with an assembly.
//
[assembly: AssemblyTitle("Northwind Order Entry App")]
[assembly: AssemblyDescription("This is the Northwind Order Entry Applications Description")]
[assembly: AssemblyCompany("Northwind Traders")]
[assembly: AssemblyProduct("Northwind Traders Orders")]
[assembly: AssemblyCopyright("Copyright? Northwind Traders Corporation.  All rights reserved.")]


//
// Version information for an assembly consists of the following four values:
//
//      Major Version
//      Minor Version 
//      Build Number
//      Revision
//
// You can specify all the values or you can default the Revision and Build Numbers 
// by using the '*' as shown below:

[assembly: AssemblyVersion("1.0.0.3")]

//
// In order to sign your assembly you must specify a key to use. Refer to the 
// Microsoft .NET Framework documentation for more information on assembly signing.
//
// Use the attributes below to control which key is used for signing. 
//
// Notes: 
//   (*) If no key is specified, the assembly is not signed.
//   (*) KeyName refers to a key that has been installed in the Crypto Service
//       Provider (CSP) on your machine. KeyFile refers to a file which contains
//       a key.
//   (*) If the KeyFile and the KeyName values are both specified, the 
//       following processing occurs:
//       (1) If the KeyName can be found in the CSP, that key is used.
//       (2) If the KeyName does not exist and the KeyFile does exist, the key 
//           in the KeyFile is installed into the CSP and used.
//   (*) In order to create a KeyFile, you can use the sn.exe (Strong Name) utility.
//       When specifying the KeyFile, the location of the KeyFile should be
//       relative to the project output directory which is
//       %Project Directory%\obj\<configuration>. For example, if your KeyFile is
//       located in the project directory, you would specify the AssemblyKeyFile 
//       attribute as [assembly: AssemblyKeyFile("..\\..\\mykey.snk")]
//   (*) Delay Signing is an advanced option - see the Microsoft .NET Framework
//       documentation for more information on this.
//
[assembly: AssemblyDelaySign(false)]
[assembly: AssemblyKeyFile("")]
[assembly: AssemblyKeyName("")]
[assembly: RegistryPermissionAttribute(SecurityAction.RequestMinimum,
All = "HKEY_CURRENT_USER")]
[assembly: RegistryPermissionAttribute(SecurityAction.RequestMinimum,
All = "HKEY_LOCAL_MACHINE")]

// Demo 4: Add Permission requests:
// Minimum set:
//Need to get to the web service
[assembly: System.Net.WebPermission(SecurityAction.RequestMinimum)]
//Need to store data in Isolated Storage
[assembly:IsolatedStorageFilePermissionAttribute(
SecurityAction.RequestMinimum, UserQuota=5242880)]
//Need to set the security principal
[assembly:SecurityPermissionAttribute(
SecurityAction.RequestMinimum, ControlPrincipal=true)]
//need to modify the thread exception
[assembly:SecurityPermissionAttribute(
SecurityAction.RequestMinimum, ControlThread=true)]
//need to be able to run...
[assembly:SecurityPermissionAttribute(
SecurityAction.RequestMinimum, Execution=true)]
//need to be able to serialize and deserialize
[assembly:SecurityPermissionAttribute(
SecurityAction.RequestMinimum, SerializationFormatter = true)]

// Refused set:
[assembly: System.Data.SqlClient.SqlClientPermission(SecurityAction.RequestRefuse)]
[assembly: System.Data.OleDb.OleDbPermission(SecurityAction.RequestRefuse)]
